# Summary

- [Introduction](README.md)
- [Getting Setup](setup.md)
- [Hello, World!](hello_world.md)
- [Describing the UI](concepts/00-index.md)
  - [Intro to Elements](concepts/vnodes.md)
  - [Intro to Components](concepts/components.md)
  - [Reusing, Importing, and Exporting Components](concepts/exporting_components.md)
  - [Conditional Rendering](concepts/conditional_rendering.md)
  - [Lists](concepts/lists.md)
- [Adding Interactivity](concepts/interactivity.md)
  - [Event handlers](concepts/event_handlers.md)
  - [Hooks and Internal State](concepts/hooks.md)
  - [Fundamental Hooks and `use_hook`](concepts/usestate.md)
  - [User Input and Controlled Components](concepts/errorhandling.md)
  - [Lifecycle, updates, and effects](concepts/lifecycles.md)

<!-- Responding to Events
State: A Component's Memory
Render and Commit
State as a Snapshot
Queueing a Series of State Updates
Updating Objects in State
Updating Arrays in State -->

<!-- Reacting to Input with State
Choosing the State Structure
Sharing State Between Components
Preserving and Resetting State
Extracting State Logic into a Reducer
Passing Data Deeply with Context
Scaling Up with Reducer and Context -->
- [Managing State](concepts/managing_state.md)
  - [Global State](concepts/sharedstate.md)
  - [Error handling](concepts/errorhandling.md)
  - [Effects](concepts/effects.md)
- [Working with Async](concepts/async.md)
  - [Tasks](concepts/asynctasks.md)
  - [Suspense](concepts/suspense.md)
  - [Async Callbacks](concepts/asynccallbacks.md)
- [Putting it all together](tutorial/index.md)
  - [New app](tutorial/new_app.md)
  - [Structuring our app](tutorial/structure.md)
  - [Defining State](tutorial/state.md)
  - [Defining Components](tutorial/components.md)
  - [Styling](tutorial/styling.md)
  - [Publishing](tutorial/publishing.md)
- [Next Steps and Advanced Topics](final/index.md)
<!-- - [Topics in Depth](depth/topics.md)
  - [RSX](depth/rsx.md)
  - [Components](depth/components.md)
  - [Props](depth/props.md)
  - [Memoization](depth/memoization.md)
  - [Performance](depth/performance.md)
  - [Testing](depth/testing.md)
- [Advanced Guides](tutorial/advanced_guides.md)
  - [Memoization](concepts/memoization.md)
  - [RSX in Depth](concepts/rsx_in_depth.md)
  - [Building Elements with NodeFactory](concepts/rsx.md)
  - [Custom Elements](concepts/custom_elements.md)
  - [Custom Renderer](concepts/custom_renderer.md)
  - [Server-side components](concepts/server_side_components.md)
  - [Bundling and Distributing](concepts/bundline.md)
- [Web]()
  - [Getting Started]()
  - [Down-casting Nodes]()
  - [Wrapping Web APIs]()
- [SSR]()
  - [Wrapping Web APIs]()
- [Desktop]()
  - [Wrapping Web APIs]()
- [Mobile]()
  - [Wrapping Web APIs]()
- [Reference Guide]()
  - [Anti-patterns]()
  - [Children]()
  - [Conditional Rendering]()
  - [Controlled Inputs]()
  - [Custom Elements]()
  - [Empty Components]()
  - [Error Handling]()
  - [Fragments]()
  - [Global CSS]()
  - [Inline Styles]()
  - [Iterators]()
  - [Listeners]()
  - [Memoization]()
  - [Node Refs]()
  - [Spread Pattern]()
  - [State Management]()
  - [Suspense]()
  - [task]()
  - [Testing]() -->

-----------

[Contributors](misc/contributors.md)
